#include <stdio.h>
#include <FL/Fl.h>
#include "main_window.h"
#include "ui.h"

//This callback is called only when the user tries to close the window
void main_window_closed_callback(Fl_Widget *W, void *Data) {
	if (g_ui_state) {
		g_ui_state->main_window_closed();
	}	
}

main_window::main_window(int x, int y, int w, int h, const char *label) :
	Fl_Window(x, y, w, h, label) {
	callback(main_window_closed_callback, NULL);
}

main_window::main_window(int w, int h, const char *label) :
	Fl_Window(w, h, label) {
	callback(main_window_closed_callback, NULL);
}

main_window::~main_window() {
	// signal UI state that this is the end:
}

int main_window::handle(int event) {
	switch(event) {
	case FL_KEYDOWN:
	case FL_KEYUP:
		if (Fl::event_key() != ' ') {
			int r = Fl_Window::handle(event);
			if (r) return r;
		}

		// register this key (used for 'shortcut' to mouse modes):
		if (event == FL_KEYDOWN)
			g_ui_state->set_key_down(Fl::event_key());
		else g_ui_state->set_no_key_down();

		return 1;
	default:
		return Fl_Window::handle(event);

	}
}
