
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _CAMERA_H_
#define _CAMERA_H_

#include <string>

#include "classes.h"
#include "locator.h"

class camera : public locator {
public:
	camera(); ///< null constructor
	camera(const c3ga::EXForm &xf,
		c3ga::mv::Float fovWidth/*, 
		c3ga::mv::Float fovHeight*/); ///< constructor; sets all member values
	camera(const camera &c); ///< copy constructor
	~camera(); ///< destructor

	camera &operator=(const camera& c); ///< assignment operator


	/// returns m_fov_width
	inline c3ga::mv::Float get_fov_width() const {return m_fov_width; }
	void set_fov_width(c3ga::mv::Float fov_width);

	/// Turns this object into a string (e.g., for storing a scene to file)
	std::string to_string() const;

private:
	c3ga::mv::Float m_fov_width; ///< 'width' of the camera sensor at distance '1' from camera position
};


#endif /* _CAMERA_H_ */
