
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _UI_VERSORS_H_
#define _UI_VERSORS_H_

#include "c3ga_util.h"

c3ga::translator create_camera_translation_versor_parallel(const c3ga::vectorE2GA &mouse_motion);
c3ga::translator create_camera_translation_versor_orthogonal(const c3ga::vectorE2GA &mouse_motion);
c3ga::rotor create_camera_rotation_versor_outside_screen_plane(const c3ga::vectorE2GA &mouse_motion);
c3ga::rotor create_camera_rotation_versor_in_screen_plane(const c3ga::vectorE2GA &mouse_position, const c3ga::vectorE2GA &mouse_motion);

c3ga::scalor create_scaling_versor(const c3ga::vectorE2GA &mouse_motion);
c3ga::EXForm create_translation_versor_orthogonal(const c3ga::EXForm &camera_xf, const c3ga::EXForm &locator_xf, const c3ga::vectorE2GA &mouse_motion);
c3ga::EXForm create_translation_versor_parallel(const c3ga::EXForm &camera_xf, const c3ga::vectorE2GA &scaled_mouse_motion_in_camera_frame);


#endif /* _UI_VERSORS_H_ */

