
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURpositionE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _RAY_H_
#define _RAY_H_

/**
This class represents a ray with position and direction.
*/
class ray {
public:
	inline ray() {} ///< null constructor
	ray(const ray &r) : m_position(r.get_position()), m_direction(r.get_direction()) {} ///< null constructor
	ray(const e3la_vec &position, const e3la_vec &direction) : m_position(position), m_direction(direction) {}  ///< all specified constructor
	inline ~ray() {}

	/// assignment operator
	inline ray &operator=(const ray &r) {
		if (this != &r) {
			set_position(r.get_position());
			set_direction(r.get_direction());
		}
		return *this;
	}

	inline const e3la_vec &get_position() const {return m_position;}
	inline const e3la_vec &get_direction() const {return m_direction;}
	inline void set_position(const e3la_vec &position) {m_position = position;}
	inline void set_direction(const e3la_vec &direction) {m_direction = direction;}

private:
	e3la_vec m_position; ///< position
	e3la_vec m_direction; ///< direction (unit vector)
};

#endif /* _RAY_H_ */
