
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <math.h>
#include <string>
#include "locator.h"
#include "c3ga_util.h"

locator::locator() {
}

locator::locator(const c3ga &TSR) {
	set_xf(TSR);
		
}

locator::locator(const p3la_tm &tm, const p3la_tm &itm) : m_tm(tm), m_itm(itm) {
	m_tr = p3la_point(m_tm.m14 / m_tm.m44, m_tm.m24 / m_tm.m44, m_tm.m34 / m_tm.m44, 1.0);
}


locator::locator(const locator &l) : m_tm(l.m_tm), m_itm(l.m_itm), m_tr(l.m_tr) {
}

locator::~locator() {
}


locator &locator::operator=(const locator &l) {
	if (this != &l) {
		m_tm = l.m_tm;
		m_itm = l.m_itm;
		m_tr = l.m_tr;
	}
	return *this;
}

void locator::set_xf(const c3ga &TSR) {
	conformal_TSR_versor_to_P3LA(TSR, m_tm);
	conformal_TSR_versor_to_P3LA(TSR.inverse(), m_itm);
	m_tr = p3la_point(m_tm.m14 / m_tm.m44, m_tm.m24 / m_tm.m44, m_tm.m34 / m_tm.m44, 1.0);
}
					 



