
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif
#include <GL/gl.h>

#include "color.h"
#include "string_util.h"

void color::glColor() const {
	GLfloat color[4];
	color[0] = (GLfloat)m_rgb[0];
	color[1] = (GLfloat)m_rgb[1];
	color[2] = (GLfloat)m_rgb[2];
	color[3] = (GLfloat)m_rgb[3];
	glColor4fv(color);
}

void color::glMaterial(int side, int parm) const {
	GLfloat color[4];
	color[0] = (GLfloat)m_rgb[0];
	color[1] = (GLfloat)m_rgb[1];
	color[2] = (GLfloat)m_rgb[2];
	color[3] = (GLfloat)m_rgb[3];
	glMaterialfv(side, parm, color);
}

void color::glLight(int idx, int parm) const {
	GLfloat color[4];
	color[0] = (GLfloat)m_rgb[0];
	color[1] = (GLfloat)m_rgb[1];
	color[2] = (GLfloat)m_rgb[2];
	color[3] = (GLfloat)m_rgb[3];
	glLightfv(idx, parm, color);
}

void color::glLightModel(int parm) const {
	GLfloat color[4];
	color[0] = (GLfloat)m_rgb[0];
	color[1] = (GLfloat)m_rgb[1];
	color[2] = (GLfloat)m_rgb[2];
	color[3] = (GLfloat)m_rgb[3];
	glLightModelfv(parm, color);
}


